/*   -*- coding: utf-8 -*-  */
/***********************************************************************
 
   Module   : Ccsd
   Commande : CcsdExplorDataShell
   Fichier  : CcsdExplorDataShell.c
   Auteur   : DUCLOY
   Date     : 2012
 
************************************************************************/

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include "Explor.h"
#include "Except.h"

extern char *optarg;
extern int   optind;
int getopt();

SxmlNode *ExplorStepNode;
SxmlNode *streamListSteps;
 
void generCcsdShellCorpusBiblio()
{
  char *halImportFile;
  char *strCcsdListSxmlImportFile;
  char *strCcsdListTeiImportFile;
  SxmlNode *listCcsdSxmlImportFile;
  SxmlNode *listCcsdTeiImportFile;
  char     *strImportFilter;

  printf("<?dilib file=\"%s/bin/%sCorpusBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  printf ("# This shell is generated by CcsdExplorDataShell \n");
  printf ("echo \"---- Executing sh %s/bin/%sCorpusBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode );

  ExplorGenerDeleteHfd(ExplorStreamCode, "Corpus", "biblio");
  if ((halImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Ccsd:halImportFile")))
    {
      ExceptSetError("CcsdExplorDataShell", "DP", "Corpus/Ccsd:halImportFile is deprecated","","",2);
    }
  if ((strCcsdListSxmlImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/importFile")))
    {
      ExceptSetError("CcsdExplorDataShell", "DP", "Corpus/Ccsd:importFile is deprecated","","",2);
    }
  strImportFilter=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/importFilter");
  strCcsdListSxmlImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Ccsd:halV2ImportFile");
  strCcsdListTeiImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Ccsd:teiImportFile");
  if (!(strCcsdListSxmlImportFile||strCcsdListTeiImportFile))
    {
      ExceptSetError("CcsdExplorDataShell", "IN", "importFile (V2 or TEI) is mandatory","","",2);
    }

  printf (" (\n");
  /* if (halImportFile) printf ("cat %s/Import/%s   \n", ExplorAreaDir, halImportFile); deprecated */

  listCcsdSxmlImportFile=NULL;
  listCcsdTeiImportFile=NULL;

  if (strCcsdListSxmlImportFile)
    {
      SxmlNode *iFileNode;
      listCcsdSxmlImportFile=SxmlFromString(strCcsdListSxmlImportFile);
      SxmlReset (listCcsdSxmlImportFile);
      while ((iFileNode=SxmlNextNode(listCcsdSxmlImportFile)))
	{
	  printf ("cat %s/Import/%s   \\\n", ExplorAreaDir, SxmlLeafText(iFileNode));
	  printf ("  | CcsdHal2CorpusStep1   \\\n");
	  printf ("  | SxmlUnIndent  \\\n");
	  printf ("   | CcsdHal2CorpusStep2   \n");
	}
    }
  if(strCcsdListTeiImportFile)
    {
      SxmlNode *iFileNode;
      listCcsdTeiImportFile=SxmlFromString(strCcsdListTeiImportFile);
      SxmlReset (listCcsdTeiImportFile);
      while ((iFileNode=SxmlNextNode(listCcsdTeiImportFile)))
	{
	  printf ("cat %s/Import/%s   \\\n", ExplorAreaDir, SxmlLeafText(iFileNode));
	  printf ("   | CcsdHalTei2Corpus   \n");
	}
    }
  printf (" )  | sort -u    \\\n");
  if(strImportFilter)
    {
      SxmlNode *importFilterList;
      SxmlNode *importFilter;
      if ((importFilterList=SxmlFromString(strImportFilter)))
	{
	  SxmlReset(importFilterList);
	  while ((importFilter=SxmlNextNode(importFilterList)))
	    {
	      printf("       |  %s     \\\n", SxmlLeafText(importFilter));
	    }
	}
    }
  /* printf ("   | SxmlRecordPutKey -b hal  \\\n"); */
  printf ("   | TeiPutRefToIdno -t wicri:Area/%s/Corpus  \\\n", ExplorStreamCode );
  printf ("   | HfdBuild -h %s/Data/%s/Corpus/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Corpus, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Corpus/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by CcsdExplorDataShells /  generCcsdShellCorpusBiblio() \n");
  printf("%s/Make/%s/Corpus/biblio: ", ExplorAreaDir, ExplorStreamCode);
  /* if (halImportFile)  printf("                %s/Import/%s \n", ExplorAreaDir, halImportFile); */
  if (listCcsdSxmlImportFile)
    {
      SxmlNode *iFileNode;
      SxmlReset (listCcsdSxmlImportFile);
      while ((iFileNode=SxmlNextNode(listCcsdSxmlImportFile)))
	{
	  printf ("\\\n           %s/Import/%s ", ExplorAreaDir, SxmlLeafText(iFileNode));
	  /*	  if (SxmlNextSibling(iFileNode))   printf("      \\\n");
		  else printf("      \n"); */
	}
    }
  if (listCcsdTeiImportFile)
    {
      SxmlNode *iFileNode;
      SxmlReset (listCcsdTeiImportFile);
      while ((iFileNode=SxmlNextNode(listCcsdTeiImportFile)))
	{
	  printf ("\\\n           %s/Import/%s ", ExplorAreaDir, SxmlLeafText(iFileNode));
	}
    }
  printf("\n\tsh %s/bin/%sCorpusBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Corpus/biblio\n\n", ExplorAreaDir, ExplorStreamCode);
  
}

void generCcsdShellCurationBiblio()
{
  SxmlNode *previousStep;
  char *codePrevious;

  printf("<?dilib file=\"%s/bin/%sCurationBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  printf ("# This file is generated by Dilib / Ccsd / CcsdExplorDataShell / generCcsdShellCurationBiblio  \n");
  printf ("echo \"---- Executing sh %s/bin/%sCurationBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode );
  ExplorGenerDeleteHfd(ExplorStreamCode, "Curation", "biblio");
  previousStep=SxmlPreviousSibling(ExplorStepNode);
  codePrevious=SxmlLeafText(previousStep);
  printf (" HfdCat %s/Data/%s/%s/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf ("   | SgmlFast -c 1  \\\n");
  printf ("   | TeiPutRefToIdno -t wicri:Area/%s/Curation  \\\n", ExplorStreamCode );
  printf ("   | CcsdHalAffiliationSetPays   \\\n");
  printf (" |  TeiKeywordsFromTable  -s mix -l en  -m $DILIB/data/Wicri/Metadata/IndexTopicEn2Fr.tab  -S Wicri -T topic -L fr \\\n");
  printf (" |  TeiKeywordsFromTable  -s mix -l fr  -m $DILIB/data/Wicri/Metadata/IndexTopicFr2Fr.tab  -S Wicri -T topic -L fr \\\n");
  printf (" |  TeiKeywordsFromTable  -s mix -l en  -m $DILIB/data/Wicri/Metadata/IndexGeoEn2Fr.tab -S Wicri -T geographic -L fr \\\n");
  printf (" |  TeiKeywordsFromTable  -s mix -l fr  -m $DILIB/data/Wicri/Metadata/PaysToPays.tab   -S Wicri -T geographic -L fr \\\n");
  ExplorCurationRecordOperations(ExplorStreamCode, "Curation");
  printf ("   | HfdBuild -h %s/Data/%s/Curation/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Curation, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Curation/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by CcsdExplorDataShells /  generCcsdShellCurationBiblio() \n");
  printf("%s/Make/%s/Curation/biblio: \\\n", ExplorAreaDir, ExplorStreamCode);
  printf("                $(DILIB)/data/Wicri/Metadata/BigUnivToPays.tab \\\n");
  /*  printf("                $(DILIB)//data/Wicri/BigUnivKey.fr.tab \\\n"); */
  printf("                $(DILIB)//data/Wicri/Metadata/IsoC2ToPays.tab \\\n");
  printf("                %s/Make/%s/%s.step \n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf("\tsh %s/bin/%sCurationBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Curation/biblio\n\n", ExplorAreaDir, ExplorStreamCode);

}

void generCcsdShellAnaExplBiblio(char *step)
{
  printf("<?dilib file=\"%s/bin/%s%sBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode, step );
  printf ("#!/bin/sh\n");
  printf ("# This file is generated by Dilib / Ccsd / CcsdExplorDataShells / generCcsdShellAnaExplBiblio  \n");
  printf ("echo \"---- Executing sh %s/bin/%s%sBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode, step );
  ExplorGenerDeleteHfd(ExplorStreamCode, step, "biblio");
  printf (" HfdCat %s/Data/%s/Curation/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode);
  /* printf ("   | SgmlFast -c 1  \\\n"); */
  ExplorExplorationCommonOperations(ExplorStreamCode, step, 1);
  ExplorGenerBuildBiblio(ExplorStreamCode, step, NULL);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by CcsdExplorDataShells /  generCcsdShellAnaExplBiblio  \n");
  printf("%s/Make/%s/%s/biblio: \\\n ", ExplorAreaDir, ExplorStreamCode, step);
  printf("                %s/Make/%s/Curation.step \n", ExplorAreaDir, ExplorStreamCode);
  printf("\tsh %s/bin/%s%sBiblio.sh\n", ExplorAreaDir, ExplorStreamCode, step );
  printf("\ttouch %s/Make/%s/%s/biblio\n\n", ExplorAreaDir, ExplorStreamCode, step);
}

int main (int argc, char **argv) {
  int cOption;

  char *pathParamFile;

  pathParamFile=NULL;
  
   while((cOption=getopt(argc,argv,"s:t:"))!=EOF)
     {switch (cOption)
	 {
	 case 's':
	   ExplorStreamCode=optarg;
	   break;
	 case 't':
	   pathParamFile=optarg;
	   break;
	 }
     }

   ExplorParamInit(pathParamFile);
   streamListSteps=SxmlFromString(ExplorGetFromDictK3("Area", ExplorStreamCode, "listSteps"));
   ExplorGenerShellCreateData( ExplorStreamCode, streamListSteps);

   SxmlReset(streamListSteps);
   while ((ExplorStepNode=SxmlNextNode(streamListSteps))) 
    {
      char *stepCode;
      stepCode=SxmlLeafText(ExplorStepNode);
      if(strcmp(stepCode, "Corpus")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generCcsdShellCorpusBiblio();
	  continue;
	}
      if(strcmp(stepCode, "Curation")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generCcsdShellCurationBiblio();
	  continue;
	}
      if(strcmp(stepCode, "Checkpoint")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generCcsdShellAnaExplBiblio( "Checkpoint");
	  continue;
	}
      if(strcmp(stepCode, "Exploration")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generCcsdShellAnaExplBiblio("Exploration");
	  continue;
	}
    }
   /* ExplorGenerAllShellsIndex(ExplorStreamCode, streamListSteps); */
   ExplorGenerAllShellsIndex(ExplorStreamCode);
   exit (EXIT_SUCCESS);
}
