#
#   Module  : CharSet
#   File    : CharSet.mk
#

#  WARNING : The source reference for this file is on 
#            wiki: Wicri/Outils (fr)
#            page: Wicri:Dilib source, module CharSet

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/CharSet.mod:  $(DILIB)/Date/CharSet.include     \
                            $(DILIB)/Date/CharSet.man         \
                            $(DILIB)/Date/CharSet.lib         \
                            $(DILIB)/Date/CharSetBuffer.lib   \
                            $(DILIB)/Date/CharSet.bin
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/CharSet.include: $(DILIB)/include/CharSet.h       \
                               $(DILIB)/include/CharSetTabO.h   \
                               $(DILIB)/include/CharSetBuffer.h \
                               $(DILIB)/include/CharSetEbcdic.h
	$(TOUCH)

$(DILIB)/include/CharSet.h : $(DILIB_IMPORT)/CharSet/CharSet.h
	cp $(DILIB_IMPORT)/CharSet/CharSet.h $@

$(DILIB)/include/CharSetBuffer.h : $(DILIB_IMPORT)/CharSet/CharSetBuffer.h \
                                   $(DILIB_IMPORT)/CharSet/CharSet.h       \
                                   $(DILIB)/include/Buffer.h 
	cp $(DILIB_IMPORT)/CharSet/CharSetBuffer.h $@

$(DILIB)/include/CharSetTabO.h : $(DILIB_IMPORT)/CharSet/CharSetTabO.h
	cp $(DILIB_IMPORT)/CharSet/CharSetTabO.h $@

$(DILIB)/include/CharSetEbcdic.h : $(DILIB_IMPORT)/CharSet/CharSetEbcdic.h
	cp $(DILIB_IMPORT)/CharSet/CharSetEbcdic.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/CharSet.lib: $(DILIB)/Date/CharSetCtoA.o   \
                           $(DILIB)/Date/CharSetAtoS.o   \
                           $(DILIB)/Date/CharSetAtoSO.o  \
                           $(DILIB)/Date/CharSetOtoA.o   \
                           $(DILIB)/Date/CharSetMisc.o  
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/CharSetCtoA.o:$(DILIB_IMPORT)/CharSet/CharSetCtoA.c   \
                            $(DILIB)/Date/CharSet.include
	$(CC) $(DILIB_IMPORT)/CharSet/CharSetCtoA.c -c -o CharSetCtoA.o
	ar ruv $(DILIB)/lib/libDilib.a CharSetCtoA.o
	$(TOUCH)

$(DILIB)/Date/CharSetMisc.o: $(DILIB_IMPORT)/CharSet/CharSetMisc.c
	$(CC) $(DILIB_IMPORT)/CharSet/CharSetMisc.c -c -o CharSetMisc.o
	ar ruv $(DILIB)/lib/libDilib.a CharSetMisc.o
	$(TOUCH)

$(DILIB)/Date/CharSetOtoA.o: $(DILIB_IMPORT)/CharSet/CharSetOtoA.c
	$(CC) $(DILIB_IMPORT)/CharSet/CharSetOtoA.c -c -o CharSetOtoA.o
	ar ruv $(DILIB)/lib/libDilib.a CharSetOtoA.o
	$(TOUCH)

$(DILIB)/Date/CharSetAtoS.o: $(DILIB_IMPORT)/CharSet/CharSetAtoS.c        \
                  $(DILIB)/Date/CharSet.include                    \
                  $(DILIB)/include/Buffer.h
	$(CC) $(DILIB_IMPORT)/CharSet/CharSetAtoS.c                       \
	           -I$(DILIB)/include    \
	           -c -o CharSetAtoS.o
	ar ruv $(DILIB)/lib/libDilib.a CharSetAtoS.o
	$(TOUCH)

$(DILIB)/Date/CharSetAtoSO.o: $(DILIB_IMPORT)/CharSet/CharSetAtoSO.c        \
                  $(DILIB)/Date/CharSet.include                      \
                  $(DILIB)/include/Buffer.h
	$(CC) $(DILIB_IMPORT)/CharSet/CharSetAtoSO.c                         \
	           -I$(DILIB)/include      \
	           -c -o CharSetAtoSO.o
	ar ruv $(DILIB)/lib/libDilib.a CharSetAtoSO.o
	$(TOUCH)

$(DILIB)/Date/CharSetBuffer.lib: $(DILIB)/Date/CharSetUrl.o   \
                                  $(DILIB)/Date/CharSetToHtml.o  
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/CharSetUrl.o: $(DILIB_IMPORT)/CharSet/CharSetUrl.c        \
                                   $(DILIB)/Date/CharSet.include        \
                                   $(DILIB)/include/CharSetBuffer.h
	$(CC) $(DILIB_IMPORT)/CharSet/CharSetUrl.c                         \
	           -I$(DILIB)/include      \
	           -c -o CharSetUrl.o
	ar ruv $(DILIB)/lib/libDilib.a CharSetUrl.o
	$(TOUCH)

$(DILIB)/Date/CharSetToHtml.o: $(DILIB_IMPORT)/CharSet/CharSetToHtml.c        \
                                   $(DILIB)/Date/CharSet.include        \
                                   $(DILIB)/include/CharSetBuffer.h
	$(CC) $(DILIB_IMPORT)/CharSet/CharSetToHtml.c                         \
	           -I$(DILIB)/include      \
	           -c -o CharSetToHtml.o
	ar ruv $(DILIB)/lib/libDilib.a CharSetToHtml.o
	$(TOUCH)


#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/CharSet.bin: $(DILIB)/bin/CharSetTr
	$(TOUCH)

$(DILIB)/bin/CharSetTr: $(DILIB_IMPORT)/CharSet/CharSetTr.c  \
                        $(DILIB)/Date/CharSet.lib            \
                        $(DILIB)/Date/Buffer.o
	$(CC) $(DILIB_IMPORT)/CharSet/CharSetTr.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#--------------------------------------------------------------------
#    La Documentation par man d'Unix

$(DILIB)/Date/CharSet.man:$(DILIB)/man/man1/CharSetIntro.1  \
                          $(DILIB)/man/man1/CharSetTr.1     \
                          $(DILIB)/man/man5/CharSet.5       \
                          $(DILIB)/man/man3/CharSet.3 
	$(TOUCH)

$(DILIB)/man/man1/CharSetIntro.1: $(DILIB_IMPORT)/CharSet/CharSetIntro.1.man
	$(MAKE_MAN) $(DILIB_IMPORT)/CharSet/CharSetIntro.1.man CharSet   $@

$(DILIB)/man/man1/CharSetTr.1: $(DILIB_IMPORT)/CharSet/CharSetTr.1.man
	$(MAKE_MAN) $(DILIB_IMPORT)/CharSet/CharSetTr.1.man CharSet   $@

$(DILIB)/man/man5/CharSet.5: $(DILIB_IMPORT)/CharSet/CharSet.5.man
	$(MAKE_MAN) $(DILIB_IMPORT)/CharSet/CharSet.5.man CharSet   $@

$(DILIB)/man/man3/CharSet.3: $(DILIB_IMPORT)/CharSet/CharSet.3.man
	$(MAKE_MAN) $(DILIB_IMPORT)/CharSet/CharSet.3.man CharSet   $@
	cp $(DILIB_IMPORT)/CharSet/CharSet.3.rman $(DILIB)/man/man3/CharSetOtoA.3
	cp $(DILIB_IMPORT)/CharSet/CharSet.3.rman $(DILIB)/man/man3/CharSetCtoA.3

#----------------- end CharSet.mk ----------------------------------
