
#   Module  : Eurovoc
#   Fichier : Eurovoc.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Eurovoc.mod:  $(DILIB)/Date/Eurovoc.bin  \
                                   $(DILIB)/Date/Eurovoc.data
	$(TOUCH)

#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/Eurovoc.bin: $(DILIB)/bin/EurovocCreateConceptTable \
                               $(DILIB)/bin/EurovocMultiLingTabFromSxml
	$(TOUCH)

$(DILIB)/bin/EurovocCreateConceptTable:  $(DILIB_IMPORT)/Eurovoc/EurovocCreateConceptTable.lex
	$(LEX) $(DILIB_IMPORT)/Eurovoc/EurovocCreateConceptTable.lex
	$(CC) lex.yy.c -ll -o  $@

 $(DILIB)/bin/EurovocMultiLingTabFromSxml:  $(DILIB_IMPORT)/Eurovoc/EurovocMultiLingTabFromSxml.c \
                          $(DILIB)/Date/Buffer.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Eurovoc/EurovocMultiLingTabFromSxml.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#------------------------------------------------------------------
#      data
#

$(DILIB)/Date/Eurovoc.data: $(DILIB)/data/Eurovoc/En2Fr.tab
	$(TOUCH)

 $(DILIB)/data/Eurovoc/En2Fr.tab: $(DILIB_IMPORT)/Eurovoc/Data/listCptEnFr.csv \
                                  $(DILIB)/bin/SmwCsvToSxml                   \
                                  $(DILIB)/bin/EurovocMultiLingTabFromSxml
	SmwCsvToSxml < $(DILIB_IMPORT)/Eurovoc/Data/listCptEnFr.csv | EurovocMultiLingTabFromSxml > $@

#---------------- end Eurovoc.mk -----------------------
