.TH Except 3 "19 July 1994"
.SH NAME
Except, \- Exceptions handling
.SH SYNOPSIS
.LP
.nf
.ft B
#include "Except.h"
.ft
.fi
.SS Exception object
.nf
.ft B
Exception *ExceptionCreate(mod1,cod1,mesBegin,param,mesEnd,lev1)
     char *mod1;
     char *cod1;
     char *mesBegin;
     char *param;
     char *mesEnd;
     int  lev1;
.ft
.fi
.LP
.nf
.ft B
char *ExceptionModule(e)
	Exception *e;
.ft
.fi
.LP
.nf
.ft B
char *ExceptionCode(e)
	Exception *e;
.ft
.fi
.LP
.nf
.ft B
char *ExceptionMessage(e)
	Exception *e;
.ft
.fi
.LP
.nf
.ft B
char *ExceptionLevel(e)
	Exception *e;
.ft
.fi
.SS Exceptions setting and handling
.nf
.ft B
void *ExceptSetError(mod1,cod1,mesBegin,param,mesEnd,lev1)
     char *mod1;
     char *cod1;
     char *mesBegin;
     char *param;
     char *mesEnd;
     int  lev1;
.ft
.fi
.LP
.SH DESCRIPTION
.SS Exception object
Exception handling mechanism is based on an internal object
called
.IR  Exception .
caracteristics of this object can be obtained by the following methods:
.TP 10
.B ExceptionModule
returns a string contaning the name of a module in which the exception has
been set.
.TP
.B ExceptionCode
returns a string contaning the error code.
.TP
.B ExceptionMessage
returns a string contaning the provided diagnostic message.
.TP
.B ExceptionLevel
returns an integer contaning the level of exception (0: warning, 1: error).
.LP
.B ExceptionCreate
creates an Exception object and returns a pointer on it.
This function is an internal one (use ExceptSetError).
.SS Setting an exception
.LP
.B ExceptSetError
must be called when an exception condition is encountered with following
paarameters:
.TP 10
.I mod1
name of module in which Exception happens,
.TP
.I cod1
code of given exception,
.TP
.I mesBegin
implicit begin of diagnostic message.
.TP
.I mesEnd
implicit end of diagnostic message.
.TP
.I param
parameter of diagnostic message.
.TP
.I lev1
exception level.
.SH WARNING
Parameters for command
.B ExceptionCreate
are subject to be modified.

