/**********************************************************************
*
*  projet   : DilibPro
*  module   : Except
*  fichier  : Except.h
*  Auteur   : Jacques DUCLOY
*  Date     : Janvier 93
*******************************************************************************
*
* Copyright (c) 1994 CNRS/CRIN & INRIA Lorraine
* 
***********************************************************************/

#ifndef _DILIB_EXCEPT_H
#define _DILIB_EXCEPT_H
#include <string.h>

struct Exception_struct
{
  char                     *module;
  char                     *code;
  char                     *messBegin;
  char                     *messEnd;
  char                     *messParam;
  int                      level;
  struct Exception_struct *prev;
};

extern char *ExceptionCommand;

typedef struct Exception_struct Exception;

#define ExceptionModule(x)    x->module
#define ExceptionCode(x)      x->code
#define ExceptionMessBegin(x) x->messBegin
#define ExceptionMessParam(x) x->messParam
#define ExceptionMessEnd(x)   x->messEnd
#define ExceptionLevel(x)     x->level
#define ExceptionCommand(x)   (ExceptionCommand)

#define ExceptModule(x)    x->module
#define ExceptCode(x)      x->code
#define ExceptMessBegin(x) x->messBegin
#define ExceptMessParam(x) x->messParam
#define ExceptMessEnd(x)   x->messEnd
#define ExceptLevel(x)     x->level

#define ExceptSetCommand(m) (ExceptionCommand=(m))

extern Exception  *ExceptLast;
void        ExceptImplicitAction();

int         ExceptHasBeenSet();
void        ExceptReset();
void        ExceptSetError();
void        ExceptPrint();
void        ExceptOnGlobal();
void        ExceptOnModule();
void        ExceptOnCode();

#endif /* _DILIB_EXCEPT_H */






