/***********************************************************************
*
* Projet   : DilibPro
* Module   : Index
* Fichier  : Index.h
* Auteur   : Ducloy
* Date     : 1/94
********************************************************************************
*
* Copyright (c) 1994 CNRS/CRIN & INRIA Lorraine
* 
*************************************************************************/

#ifndef INDEX_H
#define INDEX_H

#include "SgmlInput.h"
#include "DamHfd.h"

struct IndexListDesc_struct
{
  char     *tagEntryName;
  char     *tagList;
  char     *tagItem;
  char     *tagWeight;
  char     *formatWeight;
};

typedef struct IndexListDesc_struct IndexListDesc;

struct Index_struct
{
  DamHfd         *hfd;
  StrSearchTable *hidTable;
  char           *hidPath;
  char           *tagKey;
  char           *curPath;
  SgmlNode       *desc;
};

typedef struct Index_struct Index;

Index    *IndexOpenRead();
SgmlNode *IndexReadSgml();
SgmlNode *IndexReadSgmlRecord();
DamRecord *IndexReadRecord();

SgmlNode *IndexAnd();
SgmlNode *IndexOr();
SgmlNode *IndexAndNot();
SgmlNode *IndexWeightAnd();
SgmlNode *IndexWeightOr();
SgmlNode *IndexOrWeight();
SgmlNode *IndexInsertReverse();
SgmlNode *IndexAddReverse();
SgmlNode *IndexExprString();
SgmlNode *IndexExpr();
SgmlNode *IndexExprCompile();

#endif /* INDEX_H */

