
#   Module  : Inra
#   Fichier : Inra.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Inra.mod: $(DILIB)/Date/Inra.bin  \
                        $(DILIB)/Date/Inra.data
	$(TOUCH)

#----------------------------------------------------------------
# bin
#

$(DILIB)/Date/Inra.bin: $(DILIB)/bin/InraHalToTei                 \
                        $(DILIB)/bin/InraHalExplorDataShells      \
                        $(DILIB)/bin/InraHalExplorSiteShell       \
                        $(DILIB)/bin/InraHalExplorSiteHtmlPhp     \
                        $(DILIB)/bin/InraHalAffiliationSetCountry \
                        $(DILIB)/bin/InraHalCurationCountry       \
                        $(DILIB)/bin/InraHalToSxml
	$(TOUCH)

$(DILIB)/bin/InraHalToTei:  $(DILIB_IMPORT)/Inra/InraHalToTei.c  \
                          $(DILIB)/Date/SxmlNode.lib         \
                          $(DILIB)/Date/Tei.lib
	$(CC)  $(DILIB_IMPORT)/Inra/InraHalToTei.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InraHalToSxml:  $(DILIB_IMPORT)/Inra/InraHalToSxml.lex
	$(LEX) $(DILIB_IMPORT)/Inra/InraHalToSxml.lex
	$(CC) lex.yy.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -ll -o  $@

$(DILIB)/bin/InraHalExplorDataShells: $(DILIB_IMPORT)/Inra/InraHalExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inra/InraHalExplorDataShells.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InraHalExplorSiteShell: $(DILIB_IMPORT)/Inra/InraHalExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inra/InraHalExplorSiteShell.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InraHalExplorSiteHtmlPhp: $(DILIB_IMPORT)/Inra/InraHalExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inra/InraHalExplorSiteHtmlPhp.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InraHalAffiliationSetCountry: $(DILIB_IMPORT)/Inra/InraHalAffiliationSetCountry.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Wicri.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inra/InraHalAffiliationSetCountry.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InraHalCurationCountry: $(DILIB_IMPORT)/Inra/InraHalCurationCountry.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Wicri.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inra/InraHalCurationCountry.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#----------------------------------------------------------------
# data
#
$(DILIB)/Date/Inra.data: $(DILIB)/data/Inra/HalExplorParam.data.tab  \
                         $(DILIB)/data/Inra/HalExplorParam.en.tab  \
                         $(DILIB)/data/Inra/HalExplorParam.fr.tab  \
                         $(DILIB)/data/icons/logoProdInra.jpg
	$(TOUCH)

$(DILIB)/data/icons/logoProdInra.jpg: $(DILIB_IMPORT)/Inra/Data/logo_Prodinra2-11-300x78.jpg
	cp $(DILIB_IMPORT)/Inra/Data/logo_Prodinra2-11-300x78.jpg $@

$(DILIB)/data/Inra/HalExplorParam.data.tab: $(DILIB_IMPORT)/Inra/Data/HalExplorParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/Inra/Data/HalExplorParam.data.wiki > $@

$(DILIB)/data/Inra/HalExplorParam.en.tab: $(DILIB_IMPORT)/Inra/Data/HalExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/Inra/Data/HalExplorParam.en.wiki > $@

$(DILIB)/data/Inra/HalExplorParam.fr.tab: $(DILIB_IMPORT)/Inra/Data/HalExplorParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/Inra/Data/HalExplorParam.fr.wiki > $@

#--------------------------- End Inra.mk ---------------------------
