
# Module    MediaWiki
# Fichier   MediaWiki.mk

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/MediaWiki.mod: $(DILIB)/Date/MediaWiki.include     \
                                    $(DILIB)/Date/MediaWiki.lib         \
                                    $(DILIB)/Date/MediaWiki.bin
	$(TOUCH)

#------------------------------------------------------------------
#  include files
#

$(DILIB)/Date/MediaWiki.include:  $(DILIB)/include/MediaWiki.h
	$(TOUCH)

$(DILIB)/include/MediaWiki.h:  $(DILIB_IMPORT)/MediaWiki/MediaWiki.h
	cp  $(DILIB_IMPORT)/MediaWiki/MediaWiki.h $@

#------------------------------------------------------------------
#  library
#


$(DILIB)/Date/MediaWiki.lib : $(DILIB)/Date/MediaWikiText.o         \
                             $(DILIB)/Date/MediaWikiExportTools.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/MediaWikiText.o:$(DILIB_IMPORT)/MediaWiki/MediaWikiText.c  \
                       $(DILIB)/include/MediaWiki.h
	$(CC) $(DILIB_IMPORT)/MediaWiki/MediaWikiText.c       -Wall      \
	           -I$(DILIB)/include                                    \
	           -c -o MediaWikiText.o
	ar ruv $(DILIB)/lib/libDilib.a MediaWikiText.o
	$(TOUCH)

$(DILIB)/Date/MediaWikiExportTools.o:$(DILIB_IMPORT)/MediaWiki/MediaWikiExportTools.c  \
                       $(DILIB)/include/MediaWiki.h
	$(CC) $(DILIB_IMPORT)/MediaWiki/MediaWikiExportTools.c       -Wall      \
	           -I$(DILIB)/include                                    \
	           -c -o MediaWikiExportTools.o
	ar ruv $(DILIB)/lib/libDilib.a MediaWikiExportTools.o
	$(TOUCH)


#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/MediaWiki.bin: $(DILIB)/bin/MediaWikiTable2SxmlStep1              \
                                    $(DILIB)/bin/MediaWikiTable2SxmlStep2       \
                                    $(DILIB)/bin/MediaWikiTable2Sxml            \
                                    $(DILIB)/bin/MediaWikiTable2SxmlRowCol      \
                                    $(DILIB)/bin/MediaWikiCleanTable            \
                                    $(DILIB)/bin/MediaWikiTableTransformCol     \
                                    $(DILIB)/bin/MediaWikiImportClean           \
                                    $(DILIB)/bin/MediaWikiExportCommand         \
                                    $(DILIB)/bin/MediaWikiExtractSources        \
                                    $(DILIB)/bin/MediaWikiGeoStatMap            \
                                    $(DILIB)/bin/MediaWikiTableElemChimie       \
                                    $(DILIB)/bin/MediaWikiEasyTable2Sxml        \
                                    $(DILIB)/bin/SmwCsvToSxml
	$(TOUCH)

$(DILIB)/bin/MediaWikiTable2SxmlStep1:  $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2SxmlStep1.lex
	$(LEX) $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2SxmlStep1.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/MediaWikiCleanTable:  $(DILIB_IMPORT)/MediaWiki/MediaWikiCleanTable.lex
	$(LEX) $(DILIB_IMPORT)/MediaWiki/MediaWikiCleanTable.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/MediaWikiTable2SxmlRowCol:  $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2SxmlRowCol.lex
	$(LEX) $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2SxmlRowCol.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/MediaWikiTable2SxmlStep2:  $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2SxmlStep2.lex
	$(LEX) $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2SxmlStep2.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/MediaWikiTable2Sxml: $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2SxmlStep1.lex \
                                  $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2SxmlStep2.lex \
                                  $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2Sxml
	cp $(DILIB_IMPORT)/MediaWiki/MediaWikiTable2Sxml $@
	chmod +x $@

$(DILIB)/bin/MediaWikiEasyTable2Sxml: $(DILIB_IMPORT)/MediaWiki/MediaWikiEasyTable2Sxml  \
                                      $(DILIB)/bin/MediaWikiTableTransformCol
	cp $(DILIB_IMPORT)/MediaWiki/MediaWikiEasyTable2Sxml $@
	chmod +x $@


$(DILIB)/bin/MediaWikiImportClean:  $(DILIB_IMPORT)/MediaWiki/MediaWikiImportClean.lex
	$(LEX) $(DILIB_IMPORT)/MediaWiki/MediaWikiImportClean.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/MediaWikiExtractSources:  $(DILIB_IMPORT)/MediaWiki/MediaWikiExtractSources.lex
	$(LEX) $(DILIB_IMPORT)/MediaWiki/MediaWikiExtractSources.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/SmwCsvToSxml:  $(DILIB_IMPORT)/MediaWiki/SmwCsvToSxml.c  \
                            $(DILIB)/Date/Buffer.lib           \
                            $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)//MediaWiki/SmwCsvToSxml.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/MediaWikiGeoStatMap: $(DILIB_IMPORT)/MediaWiki/MediaWikiGeoStatMap.c \
                            $(DILIB)/Date/Buffer.lib           \
                            $(DILIB)/Date/StrDict.lib
	$(CC) $(DILIB_IMPORT)/MediaWiki/MediaWikiGeoStatMap.c -I$(DILIB)/include -lm \
	                     -lm  $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/MediaWikiTableElemChimie: $(DILIB_IMPORT)/MediaWiki/MediaWikiTableElemChimie.c \
                            $(DILIB)/Date/Buffer.lib           \
                            $(DILIB)/Date/StrDict.lib
	$(CC) $(DILIB_IMPORT)/MediaWiki/MediaWikiTableElemChimie.c -I$(DILIB)/include -lm \
	                     -lm  $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/MediaWikiExportCommand: $(DILIB_IMPORT)/MediaWiki/MediaWikiExportCommand.c \
                            $(DILIB)/Date/Buffer.lib           \
                            $(DILIB)/Date/MediaWiki.lib           \
                            $(DILIB)/Date/Explor.lib           \
                            $(DILIB)/Date/StrDict.lib
	$(CC) $(DILIB_IMPORT)/MediaWiki/MediaWikiExportCommand.c -I$(DILIB)/include -lm \
	                     -lm  $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/MediaWikiTableTransformCol: $(DILIB_IMPORT)/MediaWiki/MediaWikiTableTransformCol.c  \
                            $(DILIB)/bin/MediaWikiCleanTable          \
                            $(DILIB)/bin/MediaWikiTable2SxmlRowCol    \
                            $(DILIB)/Date/Buffer.lib           \
                            $(DILIB)/Date/MediaWiki.lib        \
                            $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/MediaWiki/MediaWikiTableTransformCol.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#----------------------------------- end MediaWiki.mk ------------


