/*   -*- coding: utf-8 -*-  */
/***********************************************************************
*
*               Module   : MediaWiki
*               Fichier  : MediaWikiGeoStatMap.c
*               Auteur   : Ali Tebbakh et Jacques Ducloy
*               Date     : Février 2013
*
************************************************************************
*
* Copyleft 2014 LorExplor 
* 
************************************************************************/
#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>
#include <time.h>
#include <math.h>
#include "StrDict.h"
#include "SxmlNode.h"
#include "MediaWiki.h"


int getopt();
extern char *optarg; 

char outputCode; /* parameter o : l:list 
                                  m:map 
                                  t:template 
                                  w:wiki */ 

StrDict *tableRegion;
StrDict *tableIndex;
StrDict *exclusionList;
StrDict *replaceList;

BufferFormatMemory *formatManager;

SxmlNode *indexNode;

char  numericMode; /*   i : int ; d : double */ 
char *keyTag;
char *numTag;
char *strRegion;
char *strFreq;
char *codeMap;
char *areaCode;
char *templateName;
char *fileMap;
char *sizeMap;
char *urlExplor;
char *serverLink;
char *httpExplorRoot;
char *streamStep;
char *indexCode;
int total;

int debugMode;

time_t timeDay;
struct tm *tmDay;
char strDate[200];

char *formatCircle=NULL;
char *formatToponyme=NULL;


int main(int argc, char **argv)
{
  int cOption;
  int isoMode;
  char *indexKey;
  double totalR;
  double cumul;
  StrDict *tablePaysToIso;
  tableRegion=NULL;
  exclusionList=NULL;
  replaceList=NULL;
  serverLink="corpus";
  isoMode=0;
  numericMode='i';
  sizeMap="600";
  httpExplorRoot=NULL;
  streamStep="Main/Exploration";
  indexCode="AffRegion.i";
  keyTag="kw";
  numTag="f";
  debugMode=0;
  
  while((cOption=getopt(argc,argv,"a:f:g:h:ik:l:m:n:o:r:s:t:u:x:wC:D:I:S:T:"))!=EOF) 
    {
      {switch (cOption)
	  { 
	  case 'a':
	    areaCode=optarg;
	    break;
	  case 'f':
	    fileMap=optarg;
	    break;
	  case 'h':
	    httpExplorRoot=optarg;
	    break;
	  case 'i':
	    isoMode=1;
	    break;
	  case 'k':
	    keyTag=optarg;
	    break;
	  case 'l':
	    serverLink=optarg;
	    break;
	  case 'm':
	    codeMap=optarg;
	    break;
	  case 'n':
	    numTag=optarg;
	    break;
	  case 'o':
	    outputCode=optarg[0];
	  break;
	  case 'g' :
	    if (tableRegion)
	      {
		StrDictAddFromFile(tableRegion, optarg);
	      }
	    else tableRegion=StrDictFromFile(optarg);
	    break; 
	  case 's':
	    sizeMap=optarg;
	    break;
	  case 'r':
	    replaceList=StrDictFromFile(optarg);
	    break;
	  case 't':
	    templateName=optarg;
	    break;
	  case 'u':
	    urlExplor=optarg;
	    break;
	  case 'x':
	    if (!exclusionList)exclusionList=NewStrDict();
	    StrDictAddNewDatum(exclusionList, optarg, optarg);
	    break;
	  case 'w':
	    numericMode='d';
	    break;
	  case 'C':
	    formatCircle=optarg;
	    break;
	  case 'D':
	    debugMode=atoi(optarg);
	    break;
	  case 'I':
	    indexCode=optarg;
	    break;
	  case 'S':
	    streamStep=optarg;
	    break;
	  case 'T':
	    formatToponyme=optarg;
	    break;
	  }
      }
    }
  /*                                                                            */
  if (formatToponyme||formatCircle)
    {
      formatManager=NewBufferFormatMemory();
      BufferFormatMemorySet(formatManager, 'a', areaCode);
    }
  /*                                      building tableIndex ; computing total */
  tableIndex=NewStrDict();
  StrDictSetValueType(tableIndex, numericMode);
  total=0;
  cumul=0.;
  while ((indexNode=SxmlInputNextDocumentElement()))
    {
      int numFreq;
      double weight;
      strRegion=SxmlLeafText(SxmlGetFirstChildByTagName(indexNode, keyTag));
      strFreq=SxmlLeafText(SxmlGetFirstChildByTagName(indexNode, numTag));
      if (numericMode=='i') numFreq=atoi(strFreq);
      else weight=atof(strFreq);
      if ((exclusionList)&&(StrDictSearch(exclusionList, strRegion))) continue;
	      if (debugMode>0) printf("*** %s\n", strRegion);
      if (replaceList)
	{
	  char *repStr;
	  repStr=StrDictSearch(replaceList, strRegion);
	  if(repStr) strRegion=repStr;
	}
      if ((StrDictCheck(tableRegion, strRegion)))
	{
	  char *strCurFreq;
	  /* if ((strCurFreq=StrDictSearch(tableIndex, strRegion))) */
	  if (StrDictCheck(tableIndex, strRegion))
	    {
	      int subTotal;
	      int dictFreq;
	      double dictWeight;
	      static Buffer* bufInt=NULL;
	      if(numericMode=='i')
		{
		  dictFreq=StrDictSearchInt(tableIndex, strRegion);
		  if (debugMode>0) printf("*i** %d\n", dictFreq);
		  StrDictSetInt(tableIndex, strRegion, dictFreq+numFreq);
		}
	      else
		{
		  dictWeight=StrDictSearchDouble(tableIndex, strRegion);
		  if (debugMode>0) printf("*d** %f\n", dictWeight);
		  StrDictSetDouble(tableIndex, strRegion, dictWeight+weight);
		}
	      /*
	      if (!bufInt)bufInt=NewBuffer();
	      subTotal=atoi(strFreq)+atoi(strCurFreq);
	      BufferIntCpy(bufInt, subTotal);
	      StrDictSet(tableIndex, strRegion, strdup(BufferString(bufInt)));
	      free(strCurFreq);
	      */

	    }
	  else 
	    {
	      /* StrDictAddNewDatum( tableIndex, strdup(strRegion), strdup(strFreq)); */
	      if(numericMode=='i') StrDictAddNewDatumWithInt( tableIndex, strdup(strRegion), numFreq); 
	      else StrDictAddNewDatumWithDouble( tableIndex, strdup(strRegion), weight); 
	    }
	  /* total+=atoi(strFreq); */
	  if(numericMode=='i') total+=numFreq;
	  else cumul+=weight;
	}
    }
   if(numericMode=='i')totalR=(double)total;
   else totalR=cumul;

  /*                                                           init template or export file */
  switch(outputCode)
    {
    case 'w':
      printf("<page>\n");
      printf("<title>Modèle:Explor plateforme %s/%s</title>\n", areaCode, templateName);
      printf("<revision>\n");
      timeDay=time(NULL);
      tmDay=gmtime(&timeDay);
      strftime(strDate, 200, "%FT%TZ", tmDay);
      printf("<timestamp>%s</timestamp>\n", strDate);
      printf("<contributor><username>%s</username></contributor>\n", getenv("USER"));
      printf("<text xml:space=\"preserve\">\n");
    case 't':
    case 'm':
      printf("{{Début de carte}}\n");
      printf("[[File:%s|{{{taille|%s}}}px]]\n", fileMap, sizeMap);
    case 'l':
      break;
    }

  if (isoMode>0)
    {
        static Buffer *bufName=NULL;
	char *dilibRoot;
	if (!bufName)  bufName=NewBuffer();
	dilibRoot=getenv("DILIB");
	BufferStrcpy(bufName,dilibRoot);
	BufferStrcat(bufName,"/data/Wicri/Metadata/PaysToIsoC2.tab");
	tablePaysToIso=StrDictFromFile(BufferString(bufName));
    }
  StrDictIteratorReset(tableIndex);
  while ((indexKey=StrDictNext(tableIndex)))
    {
      SxmlNode *figureNode;
      char *strFigureNode;
      SxmlNode *headNode;
      SxmlNode *geoNode;
      double nRef;
      double diameter;
      char *texteToponyme;
      char *offsetToponyme;
      
      strFigureNode=StrDictSearch(tableRegion, indexKey);
      figureNode=SxmlFromString(strFigureNode);
      headNode=SxmlGetFirstChildByTagName(figureNode, "head");
      offsetToponyme=SxmlGetAttribute(headNode, "offset");
      geoNode=SxmlGetFirstChildByTagName(figureNode, "geo");
      texteToponyme=SxmlLeafText(headNode);
      if (isoMode)
	{
	  char *isoCode;
	  isoCode=StrDictSearch(tablePaysToIso, texteToponyme);
	  if (isoCode)texteToponyme=isoCode;
	}
      /* nRef=(double)atof(StrDictValue(tableIndex)); */
      if (numericMode=='i')nRef=(double) StrDictValueInt(tableIndex);
      else nRef=StrDictValueDouble(tableIndex);
      diameter= (sqrt(nRef/totalR)*(double)atof(sizeMap)/5)+3;

 if (formatToponyme||formatCircle)
    {
      BufferFormatMemorySet(formatManager, 'k', indexKey);
    }

      printf("{{G/Disque avec liens\n");
      printf(" | carte=%s \n", codeMap);
      printf(" | latitude=%s \n", SxmlGetAttribute(geoNode,"latitude"));
      printf(" | longitude=%s \n", SxmlGetAttribute(geoNode,"longitude"));
      printf(" | rayon= {{#if: {{{taille|}}}|{{#expr: 1+floor(( %3.0f * {{{taille}}}) / %s)}}|%3.0f}} \n", diameter/2, sizeMap, diameter/2);
      printf(" | couleur={{{couleur disque|Tan}}} \n");
      if (formatToponyme)
	{
	  printf(" | lien toponyme=%s \n", BufferFormatEval(formatManager, formatToponyme));
	}
      else printf(" | lien toponyme=%s \n", indexKey);
      printf(" | texte toponyme=%s \n", texteToponyme);
      printf(" | offset toponyme=%s \n", offsetToponyme);
      if (formatCircle)
	{
	  printf(" | lien disque=%s \n", BufferFormatEval(formatManager, formatCircle));
	}
      else
	{
	  if (httpExplorRoot)
	    {
	      printf(" | lien disque= %s/%s/Site/fr/%s/indexItem.php?index=%s&amp;key=%s \n", httpExplorRoot, areaCode, streamStep, indexCode, MediaWikiNameToUrlLink(indexKey));
	    }
	  else
	    {
	      printf(" | lien disque= %s:%s/%s \n", serverLink,urlExplor,MediaWikiNameToUrlLink(indexKey));
	    }
	}
      printf(" | message disque=Pour consulter la liste des %d publications de la région %s \n", StrDictValueInt(tableIndex), indexKey);
      printf("}}\n");
    }

  switch(outputCode)
    {
    case 'w':
    case 't':
    case 'm':
      printf("{{Fin de carte}}\n");
    case 'l':
      break;
    }

  switch(outputCode)
    {
    case 'w':
      printf("</text>\n");
      printf("</revision>\n");
      printf("</page>\n");
    case 'l':
    case 't':
      break;
    }
  exit(EXIT_SUCCESS);
}
