%{
#include <unistd.h>
/************************************************************************
*
*     Module   : MiniBib
*     Commande : MiniBibFromEd
*     Fichier  : MiniBibFromEd.l
*     Auteur   : Ducloy
*     Date     : 22/7/94
*
*
=========================================================================


***********************************************************************/

%}

%START DEBUT 
         /* la premiere balise rencontree est consideree comme
            balise de debut de document
         */ 
%START SEEKFIELD 
%START SEEKMVAL 
%START DATA 
%START GETVAL 
%START BEGINVAL
%START COMMENT
%START ATT
%START HTML

 void copyChar();
 void initVal();
 void initDoc();
 void purgeVal();
 void purgeDoc();
 void markFieldOrDoc();

%{

 char markVal[20];
 char markField[20];
 char markDoc[20];
 char attStringDoc[100];
 char attStringField[100];
 char markDocOrField[20];

 char *newLineString;
 char *tabString;

 int flagText;
 int currentLexState;
 int flagAtt;
 int flagAttDoc;
 int flagAttField;
 
 enum stateA { s_debut, s_seekfield, s_data, s_getval } stateAnal;

#define begin(s) { BEGIN(s); currentLexState=s;}

 enum currentS 
       {
        beginFile,
        levelFile,
        levelDoc,
        levelField,
        levelVal
        }
        currentState ;

 int docIsEmpty;
 int fieldIsEmpty;
 int valIsEmpty;
 int spaceEnCours;





%}


GID   [A-Za-z][A-Za-z0-9_:]*
GID1  [A-Za-z][A-Za-z0-9_:]*/[ ]+[A-Za-z][A-Za-z0-9_:]*[ ]*\=


%%
^";"                BEGIN COMMENT;
<COMMENT>.          ;
<COMMENT>\n         BEGIN currentLexState;
<DEBUT>.            ;
<DEBUT>\n           ;
<DEBUT>"<"[A-Za-z][A-Za-z0-9_:]*/[ ]+[A-Za-z][A-Za-z0-9_:]*[ ]*\=   { strcpy(markDoc, yytext+1); 
                     flagAtt=1;flagAttDoc=1;
                     BEGIN ATT;
                     stateAnal=s_debut;
                    }
<DEBUT>"<"{GID}    {
                     strcpy(markDoc, yytext+1);
                     flagAtt=0;flagAttDoc=0;
                     initDoc();
                    }
<ATT>[^>]+          {
                     flagAtt=1;
                     strcpy(attStringField,yytext);
                     switch (stateAnal)
                       {
                          case s_debut:
                            strcpy(attStringDoc,yytext);
                            flagAttDoc=1;
                            initDoc();
                            break;
                          case s_seekfield:
                          case s_data:
                            markFieldOrDoc();
                            break;
                          case s_getval:
                            purgeVal();
                            if(strcmp(yytext+1, markVal)==0) initVal();
                            else markFieldOrDoc();
                            break;
                       }
                    }
<SEEKFIELD>.         ;
<SEEKFIELD>\n        ;
<SEEKFIELD>"<"[A-Za-z][A-Za-z0-9_:]*/[ ]+[A-Za-z][A-Za-z0-9_:]*[ ]*\=  {
                       strcpy(markDocOrField,yytext+1);         
                       BEGIN ATT;
                       stateAnal=s_seekfield;                  
                      }
<SEEKFIELD>"<"{GID}  {
                        strcpy(markDocOrField,yytext+1);
                        flagAtt=0;
                        markFieldOrDoc();
                      }
<SEEKMVAL>"><"{GID}  {
                         strcpy(markVal, yytext+2);
                         initVal();
                     }
<SEEKMVAL>">"[ \n\t]*    begin (DATA);
<DATA>[ \n\t]+/"<"   spaceEnCours=1;
<DATA>\n           {
                    if(flagText)printf("%s", newLineString);
                    else spaceEnCours=1; }
<DATA>\t           {
                    if(flagText)printf("%s", tabString);
                    else spaceEnCours=1; }
<DATA>[ ]           { 
                     if(flagText)ECHO;
                     else spaceEnCours=1; }
<DATA>.              copyChar();
<DATA>^[ ]*"<html>"[ \t]*\n[ \t\n]*  BEGIN HTML;
<DATA>[ \t]*\n[\n\t ]*"<html>"[ \t]*\n[ \t\n]*  BEGIN HTML;
<DATA>"<"[A-Za-z_:][A-Za-z0-9_:]*/[ ]+[A-Za-z_:][A-Za-z0-9_:]*[ ]*\=       {
                       strcpy(markDocOrField,yytext+1);              
                       BEGIN ATT;
                       stateAnal=s_data;                          
                     }
<DATA>"<"{GID}       {
                     strcpy(markDocOrField,yytext+1);
                     flagAtt=0;
                     markFieldOrDoc();
                     }
<DATA>"</"{GID}      {
                     if(strcmp(yytext+2, markDoc)==0)
                        {purgeDoc();
                        begin ( DEBUT); }
                     }
<HTML>[ \t\n]*"</html>"[ \t\n]*  BEGIN DATA;
<HTML>[ \t\n]+         putchar(' ');
<BEGINVAL>">"        begin ( GETVAL );
<BEGINVAL>">"[ \t]+    begin ( GETVAL);
<BEGINVAL>">"[ \t]*\n[\t \n]*  begin ( GETVAL);
<BEGINVAL>.          ;
<GETVAL>.            {
                     if(valIsEmpty)
                        {valIsEmpty=0;
                          printf("<%s>", markVal);
                        }
                     ECHO;
                     }
<GETVAL>[ \t]*\n[ \n\t]* purgeVal();
<GETVAL>[ \t]*       putchar (' ');
<GETVAL>"<"{GID}    {
                       flagAtt=0;
                       strcpy(markDocOrField,yytext+1);
                       purgeVal();
                       if(strcmp(yytext+1, markVal)==0) initVal();
                       else markFieldOrDoc();
                     }
<GETVAL>"<"[A-Za-z_:][A-Za-z0-9_:]*/[ ]+[A-Za-z_:][A-Za-z0-9_:]*[ ]*\=    {
                       strcpy(markDocOrField,yytext+1);
                       BEGIN ATT;
                       stateAnal=s_getval;                          
                     }
<GETVAL>"</"{GID}    {
                     if(strcmp(yytext+2, markDoc)==0)
                        {purgeDoc();
                        begin ( DEBUT); }
                     }
%%

void copyChar()
{
  if(spaceEnCours){spaceEnCours=0; putchar(' ');}
  printf("%s",yytext);
}

void initVal()
{
 currentState=levelVal;
 valIsEmpty=1;
 spaceEnCours=0;
 begin ( BEGINVAL);
}

void initDoc()
{
   docIsEmpty=1;
   spaceEnCours=0;
   currentState=levelDoc;
   begin ( SEEKFIELD);
}

void purgeVal()
{
    if (!valIsEmpty)
       { 
         printf("</%s>", markVal);
         currentState=levelField;
       }
    
    valIsEmpty=1;
}

void purgeField()
{
/* purgeVal */

   if (!valIsEmpty) printf("</%s>", markVal);
   if ((currentState==levelField)||(currentState==levelVal))  
       { 
         printf("</%s>", markField);
         currentState=levelDoc;
       }
}



void purgeDoc()
{
   purgeField();
   if ((currentState==levelDoc)&&(!docIsEmpty))
       { 
         printf("</%s>\n", markDoc);
         currentState=levelFile;
       }
}

void initField()
{
   if(docIsEmpty==1)
      {
         if (flagAttDoc) printf("<%s%s>", markDoc,attStringDoc );
         else   printf("<%s>", markDoc);
         docIsEmpty=0;
      }
   spaceEnCours=0;
    valIsEmpty=1;
   currentState=levelField;
   strcpy(markField, markDocOrField);
   if (flagAttField) printf("<%s%s>",  markField, attStringField);
   else printf("<%s>", markField);
   begin ( SEEKMVAL);
}

void markFieldOrDoc()
{
     if (strcmp(markDocOrField, markDoc)==0)
       {
          if (flagAtt) 
             {
                flagAttDoc=1;
                strcpy(attStringDoc, attStringField);
             }
          else flagAttDoc=0;
          
          purgeDoc();
          initDoc();
       }
    else 
       {
          purgeField();
          strcpy(markField, markDocOrField);
          if (flagAtt) flagAttField=1;
          else flagAttField=0;
          initField();
      }
    
}


int main(argc, argv)
     int argc;
     char **argv;
{

    int cod_arg;
    
    flagText=0;
    newLineString="&#10;";
    tabString="&#9;";

    while ((cod_arg = getopt(argc,argv,"t:n:T"))!=EOF)
      {switch(cod_arg)
	{

	case 'T' :
	  flagText=1;
	  break;

	case 't':
	  tabString=optarg;
	  break;

	case 'n':
	  newLineString=optarg;
	  break;

	default: break;

	}};

  begin ( DEBUT)
  currentState=beginFile;
   spaceEnCours=0;
    valIsEmpty=1;
  yylex();
  purgeDoc();
  exit(0);
}














