#
#   Module  : SgmlNode
#   Fichier : SgmlNode.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/SgmlNode.mod:  $(DILIB)/Date/SgmlNode.include \
                               $(DILIB)/Date/SgmlNode.lib 
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/SgmlNode.include: $(DILIB)/include/SgmlNode.h \
                                       $(DILIB)/include/SgmlNodePrivate.h \
                                       $(DILIB)/include/SgmlString.h     \
                                      $(DILIB)/include/SgmlInput.h  \
                                       $(DILIB)/include/SgmlLineExt.h   \
                                       $(DILIB)/include/SgmlCharSet.h  \
                                      $(DILIB)/include/Sgml.h 
	$(TOUCH)

$(DILIB)/include/SgmlNode.h:  $(DILIB_IMPORT)/SgmlNode/SgmlNode.h \
                             $(DILIB)/include/Buffer.h   \
                             $(DILIB)/include/DilibKernel.h   \
                             $(DILIB)/include/StrSearch.h
	cp  $(DILIB_IMPORT)/SgmlNode/SgmlNode.h $@

$(DILIB)/include/Sgml.h:  $(DILIB_IMPORT)/SgmlNode/Sgml.h \
                             $(DILIB)/include/SgmlNode.h   \
                             $(DILIB)/include/SgmlPathNum.h   \
                             $(DILIB)/include/StrSearch.h
	cp  $(DILIB_IMPORT)/SgmlNode/Sgml.h $@

$(DILIB)/include/SgmlNodePrivate.h:  $(DILIB_IMPORT)/SgmlNode/SgmlNodePrivate.h \
                                    $(DILIB)/include/SgmlNode.h
	cp  $(DILIB_IMPORT)/SgmlNode/SgmlNodePrivate.h $@

$(DILIB)/include/SgmlString.h:  $(DILIB_IMPORT)/SgmlNode/SgmlString.h \
                                    $(DILIB)/include/SgmlNode.h
	cp  $(DILIB_IMPORT)/SgmlNode/SgmlString.h $@

$(DILIB)/include/SgmlCharSet.h:  $(DILIB_IMPORT)/SgmlNode/SgmlCharSet.h \
                                    $(DILIB)/include/SgmlNode.h
	cp  $(DILIB_IMPORT)/SgmlNode/SgmlCharSet.h $@

$(DILIB)/include/SgmlLineExt.h:  $(DILIB_IMPORT)/SgmlNode/SgmlLineExt.h \
                                    $(DILIB)/include/SgmlNode.h
	cp  $(DILIB_IMPORT)/SgmlNode/SgmlLineExt.h $@

$(DILIB)/include/SgmlInput.h:  $(DILIB_IMPORT)/SgmlNode/SgmlInput.h \
                                    $(DILIB)/include/DamFile.h \
                                    $(DILIB)/include/SgmlString.h
	cp  $(DILIB_IMPORT)/SgmlNode/SgmlInput.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/SgmlNode.lib:$(DILIB)/Date/SgmlNodeCreate.o \
                           $(DILIB)/Date/SgmlCopy.o   \
                           $(DILIB)/Date/SgmlLeaf.o   \
                           $(DILIB)/Date/SgmlAtt.o  \
                           $(DILIB)/Date/SgmlMark.o  \
                           $(DILIB)/Date/SgmlCmp.o  \
                           $(DILIB)/Date/SgmlData.o  \
                           $(DILIB)/Date/SgmlPrint.o  \
                           $(DILIB)/Date/SgmlIter.o  \
                           $(DILIB)/Date/SgmlInput.o  \
                           $(DILIB)/Date/SgmlToString.o  \
                           $(DILIB)/Date/SgmlFromFile.o  \
                           $(DILIB)/Date/SgmlNodeTree.o \
                           $(DILIB)/Date/SgmlNodeDtd.o \
                           $(DILIB)/Date/SgmlStrAnal.o  \
                           $(DILIB)/Date/SgmlLineExt.o  \
                           $(DILIB)/Date/SgmlToEdTools.o \
                           $(DILIB)/Date/SgmlCharSetToLC.o \
                           $(DILIB)/Date/SgmlCharSetEntity.o \
                           $(DILIB)/Date/SgmlTreeIter.o \
                           $(DILIB)/Date/SgmlStrLeaf.o \
                           $(DILIB)/Date/SgmlSearch.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/SgmlNodeCreate.o:$(DILIB_IMPORT)/SgmlNode/SgmlNodeCreate.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlNodeCreate.c   -I$(DILIB)/include            \
	      -c -o SgmlNodeCreate.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlNodeCreate.o
	$(TOUCH)

$(DILIB)/Date/SgmlCopy.o:$(DILIB_IMPORT)/SgmlNode/SgmlCopy.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlCopy.c   -I$(DILIB)/include            \
	      -c -o SgmlCopy.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlCopy.o
	$(TOUCH)

$(DILIB)/Date/SgmlCmp.o:$(DILIB_IMPORT)/SgmlNode/SgmlCmp.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlCmp.c   -I$(DILIB)/include            \
	      -c -o SgmlCmp.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlCmp.o
	$(TOUCH)

$(DILIB)/Date/SgmlIter.o:$(DILIB_IMPORT)/SgmlNode/SgmlIter.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlIter.c   -I$(DILIB)/include            \
	      -c -o SgmlIter.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlIter.o
	$(TOUCH)

$(DILIB)/Date/SgmlAtt.o:$(DILIB_IMPORT)/SgmlNode/SgmlAtt.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlAtt.c   -I$(DILIB)/include            \
	      -c -o SgmlAtt.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlAtt.o
	$(TOUCH)

$(DILIB)/Date/SgmlNodeDtd.o:$(DILIB_IMPORT)/SgmlNode/SgmlNodeDtd.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlNodeDtd.c   -I$(DILIB)/include            \
	      -c -o SgmlNodeDtd.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlNodeDtd.o
	$(TOUCH)


$(DILIB)/Date/SgmlNodeTree.o:$(DILIB_IMPORT)/SgmlNode/SgmlNodeTree.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlNodeTree.c   -I$(DILIB)/include            \
	      -c -o SgmlNodeTree.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlNodeTree.o
	$(TOUCH)


$(DILIB)/Date/SgmlMark.o:$(DILIB_IMPORT)/SgmlNode/SgmlMark.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlMark.c   -I$(DILIB)/include            \
	      -c -o SgmlMark.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlMark.o
	$(TOUCH)

$(DILIB)/Date/SgmlLeaf.o:$(DILIB_IMPORT)/SgmlNode/SgmlLeaf.c \
                         $(DILIB)/include/SgmlNode.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlLeaf.c   -I$(DILIB)/include            \
	      -c -o SgmlLeaf.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlLeaf.o
	$(TOUCH)

$(DILIB)/Date/SgmlStrLeaf.o:$(DILIB_IMPORT)/SgmlNode/SgmlStrLeaf.c \
                         $(DILIB)/include/SgmlNode.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlStrLeaf.c   -I$(DILIB)/include            \
	      -c -o SgmlStrLeaf.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlStrLeaf.o
	$(TOUCH)

$(DILIB)/Date/SgmlPrint.o:$(DILIB_IMPORT)/SgmlNode/SgmlPrint.c \
                         $(DILIB)/include/SgmlNode.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlPrint.c   -I$(DILIB)/include            \
	      -c -o SgmlPrint.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlPrint.o
	$(TOUCH)

$(DILIB)/Date/SgmlLineExt.o:$(DILIB_IMPORT)/SgmlNode/SgmlLineExt.c \
                         $(DILIB)/include/SgmlNode.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlLineExt.c   -I$(DILIB)/include            \
	      -c -o SgmlLineExt.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlLineExt.o
	$(TOUCH)

$(DILIB)/Date/SgmlInput.o:$(DILIB_IMPORT)/SgmlNode/SgmlInput.c \
                         $(DILIB)/include/SgmlInput.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlInput.c   -I$(DILIB)/include            \
	      -c -o SgmlInput.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlInput.o
	$(TOUCH)

$(DILIB)/Date/SgmlToString.o:$(DILIB_IMPORT)/SgmlNode/SgmlToString.c \
                         $(DILIB)/include/SgmlNodePrivate.h  \
                         $(DILIB)/include/SgmlString.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlToString.c   -I$(DILIB)/include            \
	      -c -o SgmlToString.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlToString.o
	$(TOUCH)

$(DILIB)/Date/SgmlData.o:$(DILIB_IMPORT)/SgmlNode/SgmlData.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlData.c   -I$(DILIB)/include            \
	      -c -o SgmlData.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlData.o
	$(TOUCH)


$(DILIB)/Date/SgmlTreeIter.o:$(DILIB_IMPORT)/SgmlNode/SgmlTreeIter.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlTreeIter.c   -I$(DILIB)/include            \
	      -c -o SgmlTreeIter.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlTreeIter.o
	$(TOUCH)

$(DILIB)/Date/SgmlFromFile.o:$(DILIB_IMPORT)/SgmlNode/SgmlFromFile.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlFromFile.c   -I$(DILIB)/include            \
	      -c -o SgmlFromFile.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlFromFile.o
	$(TOUCH)

$(DILIB)/Date/SgmlStrAnal.o:$(DILIB_IMPORT)/SgmlNode/SgmlStrAnal.c \
                         $(DILIB)/include/SgmlString.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlStrAnal.c   -I$(DILIB)/include            \
	      -c -o SgmlStrAnal.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlStrAnal.o
	$(TOUCH)

$(DILIB)/Date/SgmlSearch.o:$(DILIB_IMPORT)/SgmlNode/SgmlSearch.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlSearch.c   -I$(DILIB)/include            \
	      -c -o SgmlSearch.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlSearch.o
	$(TOUCH)

$(DILIB)/Date/SgmlToEdTools.o:$(DILIB_IMPORT)/SgmlNode/SgmlToEdTools.c \
                         $(DILIB)/include/SgmlNode.h
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlToEdTools.c   -I$(DILIB)/include            \
	      -c -o SgmlToEdTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlToEdTools.o
	$(TOUCH)

$(DILIB)/Date/SgmlCharSetToLC.o:$(DILIB_IMPORT)/SgmlNode/SgmlCharSetToLC.c \
                           $(DILIB)/Date/SgmlNode.include 
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlCharSetToLC.c   -I$(DILIB)/include            \
	      -c -o SgmlCharSetToLC.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlCharSetToLC.o
	$(TOUCH)

$(DILIB)/Date/SgmlCharSetEntity.o:$(DILIB_IMPORT)/SgmlNode/SgmlCharSetEntity.c \
                           $(DILIB)/Date/SgmlNode.include 
	$(CC) $(DILIB_IMPORT)/SgmlNode/SgmlCharSetEntity.c   -I$(DILIB)/include            \
	      -c -o SgmlCharSetEntity.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlCharSetEntity.o
	$(TOUCH)




