#
#   Module  : SgmlPath
#   Fichier : SgmlPath.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/SgmlPath.mod:  $(DILIB)/Date/SgmlPath.include  \
                                    $(DILIB)/Date/SgmlPath.lib     \
                                    $(DILIB)/Date/SgmlPath.bin    \
                                    $(DILIB)/Date/SgmlPath.man
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/SgmlPath.include: $(DILIB)/include/SgmlPath.h \
                         $(DILIB)/include/SgmlPathNum.h
	$(TOUCH)

$(DILIB)/include/SgmlPath.h:$(DILIB_IMPORT)/SgmlPath/SgmlPath.h  \
                           $(DILIB)/include/SgmlInput.h
	cp $(DILIB_IMPORT)/SgmlPath/SgmlPath.h $@

$(DILIB)/include/SgmlPathNum.h:$(DILIB_IMPORT)/SgmlPath/SgmlPathNum.h  \
                           $(DILIB)/include/SgmlPath.h
	cp $(DILIB_IMPORT)/SgmlPath/SgmlPathNum.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/SgmlPath.lib:$(DILIB)/Date/SgmlPathList.o  \
                       $(DILIB)/Date/SgmlPath.o    \
                       $(DILIB)/Date/SgmlPathNum.o    \
                       $(DILIB)/Date/SgmlPathIterCopy.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/SgmlPathList.o:$(DILIB_IMPORT)/SgmlPath/SgmlPathList.c \
                         $(DILIB)/include/SgmlPath.h
	$(CC) $(DILIB_IMPORT)/SgmlPath/SgmlPathList.c   -I$(DILIB)/include            \
	      -c -o SgmlPathList.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlPathList.o
	$(TOUCH)

$(DILIB)/Date/SgmlPathIterCopy.o:$(DILIB_IMPORT)/SgmlPath/SgmlPathIterCopy.c \
                         $(DILIB)/include/SgmlPath.h
	$(CC) $(DILIB_IMPORT)/SgmlPath/SgmlPathIterCopy.c   -I$(DILIB)/include            \
	      -c -o SgmlPathIterCopy.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlPathIterCopy.o
	$(TOUCH)

$(DILIB)/Date/SgmlPath.o:$(DILIB_IMPORT)/SgmlPath/SgmlPath.c \
                         $(DILIB)/include/SgmlPath.h
	$(CC) $(DILIB_IMPORT)/SgmlPath/SgmlPath.c   -I$(DILIB)/include            \
	      -c -o SgmlPath.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlPath.o
	$(TOUCH)

$(DILIB)/Date/SgmlPathNum.o:$(DILIB_IMPORT)/SgmlPath/SgmlPathNum.c \
                         $(DILIB)/include/SgmlPathNum.h
	$(CC) $(DILIB_IMPORT)/SgmlPath/SgmlPathNum.c   -I$(DILIB)/include            \
	      -c -o SgmlPathNum.o
	ar ruv  $(DILIB)/lib/libDilib.a   SgmlPathNum.o
	$(TOUCH)

#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/SgmlPath.bin: $(DILIB)/bin/SgmlSetAtt   \
                         $(DILIB)/bin/SgmlSelect  \
                        $(DILIB)/bin/SgmlReplace
	$(TOUCH)

$(DILIB)/bin/SgmlSetAtt:$(DILIB_IMPORT)/SgmlPath/SgmlSetAtt.c  \
                        $(DILIB)/Date/SgmlNode.lib   \
                        $(DILIB)/Date/SgmlPath.lib 
	$(CC)  $(DILIB_IMPORT)/SgmlPath/SgmlSetAtt.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/SgmlSelect:$(DILIB_IMPORT)/SgmlPath/SgmlSelect.c  \
                        $(DILIB)/Date/SgmlNode.lib   \
                        $(DILIB)/Date/SgmlPath.lib 
	$(CC)  $(DILIB_IMPORT)/SgmlPath/SgmlSelect.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/SgmlReplace:$(DILIB_IMPORT)/SgmlPath/SgmlReplace.c  \
                        $(DILIB)/Date/SgmlNode.lib   \
                        $(DILIB)/Date/SgmlPath.lib 
	$(CC)  $(DILIB_IMPORT)/SgmlPath/SgmlReplace.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


#--------------------------------------------------------------------
#    La Documentation par man d'Unix
#

$(DILIB)/Date/SgmlPath.man:$(DILIB)/man/man1/SgmlSetAtt.1 
	$(TOUCH)

$(DILIB)/man/man1/SgmlSetAtt.1: $(DILIB_IMPORT)/SgmlPath/SgmlSetAtt.1.man
	$(MAKE_MAN) $(DILIB_IMPORT)/SgmlPath/SgmlSetAtt.1.man SgmlPath $@
