.TH SxmlNode 3 "21 January 2003"
.SH NAME
SxmlNode, SxmlNodeCreate \- basic Xml creation and access functions.
.SH SYNOPSIS
.PP
.nf
\#include "SxmlNode.h"
.fi
.SS Constructors
.PP
.nf
.ft B 
SxmlNode\(** SxmlNodeCreate(type)
	int type;
.ft
.fi
.PP
.nf
.ft B 
SxmlNode\(** SxmlFromFile(f1)
	char \(**f1;
.ft
.fi
.SS "W3C DOM Properties"
.nf
.ft B 
SxmlNode\(** SxmlFirstChild(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
SxmlNode\(** SxmlLastChild(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
SxmlNode\(** SxmlNextNode(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
SxmlNode\(** SxmlNextSibling(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
char\(** SxmlNodeName(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
int SxmlNodeType(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
char \(**SxmlNodeValue(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
SxmlNode\(** SxmlParent(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
SxmlNode\(** SxmlPreviousSibling(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.SS "DILIB Properties"
.nf
.ft B 
int SxmlIsElement(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
int SxmlIsText(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
int SxmlIsLeaf(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
int SxmlNodeHasName(n1, s1)
	SxmlNode \(**n1;
	char \(**s1;
.ft
.fi
.PP
.nf
.ft B 
int SxmlNodeHasValue(n1, s1)
	SxmlNode \(**n1;
	char \(**s1;
.ft
.fi
.PP
.nf
.ft B 
SxmlNode\(** SxmlGetFirstChildByTagName(n1, t1)
	SxmlNode \(**n1;
	char \(**t1;
.ft
.fi
.PP
.nf
.ft B 
SxmlNode\(** SxmlGetNextSiblingByTagName(n1, t1)
	SxmlNode \(**n1;
	char \(**t1;
.ft
.fi
.PP
.nf
.ft B 
int SxmlLength(n1)
	SxmlNode \(**n1;
.ft
.fi

.PP
.nf
.ft B
int SxmlNodeIntegerValue(x1)
    SxmlNode *x1;
.ft
.fi

.SS "W3C DOM Methods"
.PP
.nf
.ft B 
SxmlNode\(** SxmlClone(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
void SxmlReset(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
void SxmlAppendChild(n1, n2)
	SxmlNode \(**n1;
	SxmlNode \(**n2;
.ft
.fi
.PP
.nf
.ft B 
void SxmlRemoveChild(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
void SxmlReplaceChild(n1,n2)
	SxmlNode \(**n1;
	SxmlNode \(**n2;
.ft
.fi
.PP
.nf
.ft B 
void SxmlInsertBefore(n1, n2)
	SxmlNode \(**n1;
	SxmlNode \(**n2;
.ft
.fi
.PP
.nf
.ft B 
void SxmlInsertAfter(n1, n2)
	SxmlNode \(**n1;
	SxmlNode \(**n2;
.ft
.fi
.SS "DILIB Methods"
.PP
.nf
.ft B 
void SxmlFree(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
void SxmlFreeContent(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
void SxmlFreeChildren(n1)
	SxmlNode \(**n1;
.ft
.fi
.PP
.nf
.ft B 
void SxmlReplaceName(n1, name1)
	SxmlNode \(**n1;
	char \(**name1;
.ft
.fi
.PP
.nf
.ft B 
void SxmlAddFirstChild(np, ns)
	SxmlNode \(**np;
	SxmlNode \(**ns;
.ft
.fi
.PP
.nf
.ft B 
void SxmlReplaceValue(n1, val1)
	SxmlNode \(**n1;
	char \(**val1;
.ft
.fi

.PP
.nf
.ft B
int SxmlSetNodeIntegerValue(x1, i1)
    SxmlNode *x1;
    int      i1;
.ft
.fi

.SH DESCRIPTION
.SS Constructors
.TP
.B SxmlNodeCreate
is the basic constructor of a SxmlNode,
used by all specific constructors (see
.BR SxmlElementCreate(3), 
.BR SxmlLeafCreate(3)...)
.I type
is an integer value conformant to DOM specification (XML_NODE_ELEMENT, XML_NODE_ATTRIBUTE, XML_NODE_TEXT, XML_NODE_COMMENT...)

.TP
.B SxmlFromFile
is another constructor of a whole SxmlNode tree. It reads an XML-formatted file and translates it into a SxmlNode.

.PP
.I Warning:
All of the SxmlNode created using a constructor (may it be 
.BR SxmlFromString (3), 
.BR SxmlClone (3))
must be freed, via
.BR SxmlFree (3).

.SS "W3C DOM Properties"
.TP
.B SxmlFirstChild
returns an SxmlNode pointer on the first child of 
.I n1.
(NULL pointer is returned if 
.I n1
has no child).

.TP
.B SxmlLastChild
returns an SxmlNode pointer on the last child of 
.I n1.
(NULL pointer is returned if 
.I n1
has no child).

.TP
.B SxmlNextSibling
returns a pointer on the following sibling of 
.I n1.
(NULL pointer is returned if 
.I n1
has no such sibling).

.TP
.B SxmlPreviousSibling
returns a pointer on the preceding sibling of 
.I n1.
(NULL pointer is returned if 
.I n1
has no such sibling).

.TP
.B SxmlParent
returns a pointer on the direct parent of 
.I n1.
(NULL pointer is returned if 
.I n1
has no parent).

.TP
.B SxmlNextNode
returns a pointer on the next node of 
.I n1.
(NULL pointer is returned if all
.IR n1 's
children have been read).
.I Warning:
don't forget to run 
.BR SxmlReset (3)
before reading all 
.IR n1 's
children.

.PP
.B SxmlNodeName
returns a pointer on 
.IR n1 's
tag name.

.TP
.B SxmlNodeType
returns 
.IR n1 's
type (among XML_NODE_ELEMENT, XML_NODE_ATTRIBUTE, XML_NODE_TEXT, XML_NODE_COMMENT...).

.PP
.B SxmlNodeValue
returns a pointer on 
.IR n1 's
value.

.SS "DILIB Properties"
.TP
.B SxmlIsElement
returns 
.I true
if 
.IR n1 's
type is XML_NODE_ELEMENT (ie tag). Returns 0 otherwise.

.TP
.B SxmlIsText.
returns
.I true
if 
.IR n1 's
type is XML_NODE_TEXT. Returns 0 otherwise.

.TP
.B SxmlIsLeaf
returns
.I true
if 
.I n1
is a leaf of the XML tree, that is to say
.IR n1 's
type is XML_NODE_ELEMENT, and its child has XML_NODE_TYPE type.
Returns 0 otherwise.

.PP
.B SxmlNodeHasName
returns 0 (false) if 
.I n1
has not 
.I s1
as name.

.PP
.B SxmlNodeHasValue
returns 0 (false) if 
.I n1
has not
.I s1
as value.

.TP
.B SxmlGetFirstChildByTagName
returns the first child of
.I n1
which tag name is equal to
.IR t1 .
(NULL pointer is returned if there is no such child)

.TP
.B SxmlGetNextSiblingByTagName
returns the first of 
.IR n1 's 
next siblings which tag name equals to
.IR t1 .
(NULL pointer is returned if there is no such sibling)

.TP
.B SxmlLength
Returns children number of 
.IR n1 .
When it is a node of type XML_NODE_TEXT, returns the length of the string.

.TP
.B SxmlNodeIntegerValue
returns the integer value of 
.IR x1 .

.SS "W3C DOM Methods"
.TP
.B SxmlClone
returns a clone of node 
.I n1
(with, recursively, a copy of all its sons, attributes etc).

.TP
.B SxmlReset
resets the iterator for list nodes (see
.BR SxmlNextNode (3)).

.TP
.B SxmlAppendChild
appends 
.I n2 
to 
.I n1
children.
.I n2
thus becomes the last child of 
.IR n1 .

.TP
.B SxmlRemoveChild
removes
.I n1
from the tree where it is located. Changes nothing when 
.I n1
has no parent node.
.TP
.B SxmlPlaceChild
replaces node
.I n1
by 
.I n2
and returns
.I n2.

.PP
.B SxmlInsertBefore
inserts 
.I n2
before
.IR n1.

.PP
.B SxmlInsertAfter
inserts
.I n2
after
.IR n1.

.SS "DILIB Methods"
.TP
.B SxmlFree
is the destructor of SxmlNode. It frees all resources used by 
.IR n1 . 
Don't forget to launch it on all nodes dynamically created (by SxmlNode constructors).

.TP
.B SxmlFreeContent
is internally used to free the value, name, children and/or attributes of 
.IR n1 ,
except internal data of the node (if you want to free all, use 
.BR SxmlFree (3)).

.TP
.B SxmlFreeChildren
Frees all 
.IR n1 's
children, and removes them from its tree.

.PP
.B SxmlReplaceName
replaces 
.IR n1 's
name (ie tag name) by 
.IR name1 .

.PP
.B SxmlAddFirstChild
adds 
.I ns
as the first child of
.IR np.

.TP
.B SxmlReplaceValue
replaces
.IR n1 's
value by
.IR val1 .

.TP 
.B SxmlSetNodeIntegerValue
sets the integer value of the SxmlNode
.I x1
to value of 
.IR i1 .

.SH FILES
.nf
  $DILIB/Include/SxmlNode.h
  $DILIB_ROOT/Import/SxmlNode/SxmlNodeKernel.c
.fi
.SH "SEE ALSO"
.BR SxmlContainer (3),
.BR SxmlElement (3),
.BR SxmlString (3),
.BR SxmlText (3).
