#!/bin/sh

#
#       module SxmlNode
#

echo  \|-------------------------------------- module SxmlNode
echo  \|

gcc $DILIB_IMPORT/SxmlNode/Test/sxmlTest1.c  $DILIB_CC -o $DILIB/MakeDir/sxmlNodeTest1

$DILIB/MakeDir/sxmlNodeTest1 > $DILIB/MakeDir/sxmlNode.test1.target.data

diff  $DILIB/MakeDir/sxmlNode.test1.target.data        \
      $DILIB_IMPORT/SxmlNode/Test/sxmlNode.test1.target     \
       >  $DILIB/MakeDir/sxmlNode.test1.diff

if test -s $DILIB/MakeDir/sxmlNode.test1.diff
then 
  echo SxmlNode "****************************** ERROR SxmlNode *****"
else
  echo ----- SxmlNode Test 1 OK
  rm $DILIB/MakeDir/sxmlNode.test1.diff
  rm $DILIB/MakeDir/sxmlNodeTest1
  rm $DILIB/MakeDir/sxmlNode.test1.target.data 
fi

#==========================================================================================

gcc $DILIB_IMPORT/SxmlNode/Test/sxmlInputOutputTest.c  $DILIB_CC -o $DILIB/MakeDir/sxmlInputOutputTest

$DILIB/MakeDir/sxmlInputOutputTest < $DILIB_IMPORT/SxmlNode/Test/sxmlNodeTestInputOutput.data \
                                   >  $DILIB/MakeDir/sxmlNode.testIO.data

diff  $DILIB_IMPORT/SxmlNode/Test/sxmlNodeTestInputOutput.data \
      $DILIB/MakeDir/sxmlNode.testIO.data\
       >  $DILIB/MakeDir/sxmlNode.testIO.diff

if test -s $DILIB/MakeDir/sxmlNode.testIO.diff
then 
  echo XmlNode "****************************** ERROR XmlNode (test Input Output) *****"
else
  echo ----- SxmlNode Test Input Output OK
rm $DILIB/MakeDir/sxmlNode.testIO.data  
rm $DILIB/MakeDir/sxmlNode.testIO.diff
rm $DILIB/MakeDir/sxmlInputOutputTest
fi

#==========================================================================================

gcc $DILIB_IMPORT/SxmlNode/Test/sxmlDictTest.c  $DILIB_CC -o $DILIB/MakeDir/sxmlDictTest 

$DILIB/MakeDir/sxmlDictTest > $DILIB/MakeDir/sxmlNode.testDict.data

diff  $DILIB/MakeDir/sxmlNode.testDict.data  \
      $DILIB_IMPORT/SxmlNode/Test/sxmlNode.testDict.target \
       >  $DILIB/MakeDir/sxmlNode.testDict.diff

if test -s $DILIB/MakeDir/sxmlNode.testDict.diff
then 
  echo XmlNode "****************************** ERROR XmlNode (Dict) *****"
else
  echo ----- SxmlNode Test Dict OK
rm $DILIB/MakeDir/sxmlNode.testDict.data  
rm $DILIB/MakeDir/sxmlNode.testDict.diff
rm $DILIB/MakeDir/sxmlDictTest
fi

#==========================================================================================

gcc $DILIB_IMPORT/SxmlNode/Test/sxmlTestTree.c  $DILIB_CC -o $DILIB/MakeDir/sxmlTestTree

$DILIB/MakeDir/sxmlTestTree > $DILIB/MakeDir/sxmlNode.testTree.data

diff  $DILIB/MakeDir/sxmlNode.testTree.data  \
      $DILIB_IMPORT/SxmlNode/Test/sxmlNode.testTree.target \
       >  $DILIB/MakeDir/sxmlNode.testTree.diff

if test -s $DILIB/MakeDir/sxmlNode.testTree.diff
then 
  echo XmlNode "****************************** ERROR XmlNode (Tree) *****"
else
  echo ----- SxmlNode Test Tree OK
rm $DILIB/MakeDir/sxmlNode.testTree.data  
rm $DILIB/MakeDir/sxmlNode.testTree.diff
rm $DILIB/MakeDir/sxmlTestTree
fi

#==========================================================================================

gcc $DILIB_IMPORT/SxmlNode/Test/sxmlContainerTest.c  $DILIB_CC -o $DILIB/MakeDir/sxmlContainerTest

$DILIB/MakeDir/sxmlContainerTest >  $DILIB/MakeDir/sxmlContainerTest.data

diff $DILIB/MakeDir/sxmlContainerTest.data \
     $DILIB_IMPORT/SxmlNode/Test/sxmlContainerTest.target \
    > $DILIB/MakeDir/sxmlContainerTest.diff

if test -s $DILIB/MakeDir/sxmlContainerTest.diff
then 
  echo XmlNode "****************************** ERROR XmlNode (Container) *****"
else
  echo ----- SxmlNode Test Container OK
  rm $DILIB/MakeDir/sxmlContainerTest.data
  rm $DILIB/MakeDir/sxmlContainerTest.diff
  rm $DILIB/MakeDir/sxmlContainerTest
fi

#==========================================================================================

php -f $DILIB_IMPORT/SxmlNode/Test/sxmlNode.test2.php >  $DILIB/MakeDir/sxmlNodeTest2.data

diff $DILIB_IMPORT/SxmlNode/Test/sxmlNodeTest2.target.data  \
              $DILIB/MakeDir/sxmlNodeTest2.data  > $DILIB/MakeDir/sxmlTest2.diff

if test -s $DILIB/MakeDir/sxmlTest2.diff
then 
  echo XmlNode "****************************** ERROR SxmlNode (php) *****"
else
  echo ----- SxmlNode Test PHP OK
  rm $DILIB/MakeDir/sxmlNodeTest2.data
  rm $DILIB/MakeDir/sxmlTest2.diff
fi
