#
#   Module  : SxmlProc
#   Fichier : SxmlProc.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/SxmlProc.mod:  $(DILIB)/Date/SxmlProc.include \
                                   $(DILIB)/Date/SxmlProc.lib
	$(TOUCH)


#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/SxmlProc.include: $(DILIB)/include/SxmlProcKernel.h \
                                      $(DILIB)/include/SxmlProcessor.h  \
                                      $(DILIB)/include/SxmlMemory.h    \
                                     $(DILIB)/include/SxmlDomProc.h   \
                                     $(DILIB)/include/SxmlC.h      \
                                     $(DILIB)/include/SxmlProc.h
	$(TOUCH)

$(DILIB)/include/SxmlProcKernel.h:  $(DILIB_IMPORT)/SxmlProc/SxmlProcKernel.h \
                             $(DILIB)/include/SxmlNode.h  
	cp  $(DILIB_IMPORT)/SxmlProc/SxmlProcKernel.h $@

$(DILIB)/include/SxmlMemory.h:  $(DILIB_IMPORT)/SxmlProc/SxmlMemory.h \
                             $(DILIB)/include/SxmlProcKernel.h  
	cp  $(DILIB_IMPORT)/SxmlProc/SxmlMemory.h $@

$(DILIB)/include/SxmlProcessor.h:  $(DILIB_IMPORT)/SxmlProc/SxmlProcessor.h \
                             $(DILIB)/include/SxmlMemory.h  
	cp  $(DILIB_IMPORT)/SxmlProc/SxmlProcessor.h $@

$(DILIB)/include/SxmlC.h:  $(DILIB_IMPORT)/SxmlProc/SxmlProcessor.h \
                             $(DILIB_IMPORT)/SxmlProc/SxmlC.h  
	cp  $(DILIB_IMPORT)/SxmlProc/SxmlC.h $@

$(DILIB)/include/SxmlDomProc.h:  $(DILIB_IMPORT)/SxmlProc/SxmlProcessor.h \
                             $(DILIB_IMPORT)/SxmlProc/SxmlDomProc.h  
	cp  $(DILIB_IMPORT)/SxmlProc/SxmlDomProc.h $@

$(DILIB)/include/SxmlProc.h:  $(DILIB_IMPORT)/SxmlProc/SxmlProc.h      \
                              $(DILIB_IMPORT)/SxmlProc/SxmlProcessor.h \
                              $(DILIB_IMPORT)/SxmlProc/SxmlDomProc.h   \
                             $(DILIB)/include/SxmlMemory.h
	cp  $(DILIB_IMPORT)/SxmlProc/SxmlProc.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/SxmlProc.lib:$(DILIB)/Date/SxmlProcessor.o \
                                 $(DILIB)/Date/SxmlProcImplicit.o \
                                $(DILIB)/Date/SxmlMemory.o \
                               $(DILIB)/Date/SxmlC.o     \
                               $(DILIB)/Date/SxmlDomProc.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/SxmlProcessor.o:$(DILIB_IMPORT)/SxmlProc/SxmlProcessor.c  \
                                   $(DILIB)/include/SxmlProcessor.h
	$(CC) $(DILIB_IMPORT)/SxmlProc/SxmlProcessor.c    -I$(DILIB)/include   \
	                                             -c -o SxmlProcessor.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlProcessor.o
	$(TOUCH)

$(DILIB)/Date/SxmlProcImplicit.o:$(DILIB_IMPORT)/SxmlProc/SxmlProcImplicit.c  \
                                   $(DILIB)/include/SxmlProc.h
	$(CC) $(DILIB_IMPORT)/SxmlProc/SxmlProcImplicit.c    -I$(DILIB)/include   \
	                                             -c -o SxmlProcImplicit.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlProcImplicit.o
	$(TOUCH)
 
$(DILIB)/Date/SxmlMemory.o:$(DILIB_IMPORT)/SxmlProc/SxmlMemory.c  \
                                   $(DILIB)/include/SxmlMemory.h
	$(CC) $(DILIB_IMPORT)/SxmlProc/SxmlMemory.c    -I$(DILIB)/include   \
	                                             -c -o SxmlMemory.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlMemory.o
	$(TOUCH)

$(DILIB)/Date/SxmlC.o:$(DILIB_IMPORT)/SxmlProc/SxmlC.c  \
                                   $(DILIB)/include/SxmlC.h
	$(CC) $(DILIB_IMPORT)/SxmlProc/SxmlC.c    -I$(DILIB)/include   \
	                                             -c -o SxmlC.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlC.o
	$(TOUCH)

$(DILIB)/Date/SxmlDomProc.o:$(DILIB_IMPORT)/SxmlProc/SxmlDomProc.c  \
                                   $(DILIB)/include/SxmlDomProc.h       \
                                   $(DILIB)/include/SxmlNode.h    
	$(CC) $(DILIB_IMPORT)/SxmlProc/SxmlDomProc.c    -I$(DILIB)/include   \
	                                             -c -o SxmlDomProc.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlDomProc.o
	$(TOUCH)












