/*   -*- coding: utf-8 -*-  */

/***********************************************************************
*
*        Module   : Tei
*        Fichier  : TeiAffiliation.c
*        Auteur   : J. DUCLOY
*        Date     : octobre 2012
*
************************************************************************/

#include "TeiHandler.h"

SxmlNode *TeiAffiliationSetCountry(SxmlNode *affiliation, char *country)
{
  SxmlNode *c1;
  if ((c1=SxmlGetFirstChildByTagName(affiliation, "country"))
      &&(strcmp(SxmlLeafText(c1), country)==0)) return c1;
  SxmlAppendChild(affiliation, c1=SxmlLeafCreate("country", country));
  return c1;
}

SxmlNode *TeiAffiliationUpdateFromOrgLab(SxmlNode *affiliation, SxmlNode *laboNode)
{
  SxmlNode *placeName;
  SxmlNode *countryNode;
  SxmlNode *orgNode;
  if ((placeName=SxmlGetFirstChildByTagName(laboNode, "placeName")))
    {
      SxmlAppendChild (affiliation, SxmlClone(placeName));
    }
  if ((countryNode=SxmlGetFirstChildByTagName(laboNode, "country")))
    {
      TeiAffiliationSetCountry(affiliation, SxmlLeafText(countryNode));
    }
  if ((orgNode=SxmlGetFirstChildByTagName(laboNode, "orgName")))
    {
      while (orgNode)
	{
	  SxmlAppendChild (affiliation, SxmlClone(orgNode));
	  orgNode=SxmlGetNextSiblingByTagName(orgNode, "orgName");
	}
    }
  SxmlSetAttribute(affiliation, "wicri:level", "5");
  return affiliation;
}
