/*   -*- coding: utf-8 -*-  */

/***********************************************************************
*
*        Module   : Wicri
*        Fichier  : Wicri.h
*        Auteur   : J. DUCLOY
*        Date     : octobre 2012
*
************************************************************************/
#ifndef  _WICRI_H
#define _WICRI_H

#include "StrDict.h"
#include "SxmlNode.h"
#include "RegExp.h"
#include "Buffer.h"

extern RegExp *WicriRegExpZip5;
extern RegExp *WicriRegExpZip4;

/*       sources from WicriTools.c   */

char         *WicriGetDataRoot();
StrDict      *WicriGetInterwikiTable();

char *WicriBufferCatUrl(Buffer *bufName, char *link, char *pageName);
char *WicriBufferCatWikiLink2A(Buffer *bufName, char*implicitLink, char *wikiText);

SxmlNode *WicriGenerNoCountry(char *str, char *code);

void WicriAffiliationPutPlace(SxmlNode *affiliation, char *placeStr);

char *WicriFindZip4(char *str);
char *WicriFindZip5(char *str);

/*       sources from WicriUnivTools.c   */

SxmlNode *WicriUnivFrFromLcKey(char *enStr);
SxmlNode *WicriUnivFrFromKey(char *enStr);
SxmlNode *WicriUnivFrFromSubstr(char *str);
char     *WicriUnivFindSubstrInField(char *str);
SxmlNode *WicriAffiliationSetUnivFromField(SxmlNode *affiliation, char *field);

/*       sources from ???   */

SxmlNode *WicriAffiliationSetPaysFromUrl(SxmlNode *affiliation, char *url); 
SxmlNode *WicriSetRegionOrgFromUniv(SxmlNode *affiliation, char *regionEnStr);


SxmlNode *WicriAffiliationSetPaysFromSubFieldEn(SxmlNode *affiliation, char *subField);
SxmlNode *WicriAffiliationSetPaysFromFieldEn(SxmlNode* affiliation, char *field);
SxmlNode *WicriEspagneGetRegionFromField(SxmlNode *affiliation, char *strRegion, char *regionArea);

SxmlNode *WicriAffiliationPutRegion(SxmlNode *affiliation, char *strRegion);
SxmlNode *WicriSetPaysOrgFromUniv(SxmlNode *affiliation, char *countryEnStr);


#endif /* _WICRI_H */
