/*   -*- coding: utf-8 -*-  */
#include <stdlib.h> 
#include <string.h>
#include <ctype.h>
#include "Buffer.h"
#include "Wicri.h"

SxmlNode *WicriTchecoCurationPays(SxmlNode *affiliation, SxmlNode *countryNode, char *cityStr, char *adrStr)
{
  static RegExp *tchecZip=NULL;
  char *zip;
  SxmlNode *att;
  if (!tchecZip) tchecZip=RegExpCreate("[0-9][0-9][0-9][ ]+[0-9][0-9]");
  zip=RegExpFind(tchecZip, cityStr);
  if (!zip)return NULL;
  switch (zip[0])
    {
    case '0':
    case '8':
    case '9':
      SxmlLeafSetText(countryNode, "Slovaquie");
      break;
    }
  att=SxmlGetAttributeNode(countryNode,"wicri:auto");
  SxmlFree(att);
  SxmlSetAttribute(affiliation, "wicri:level", "1");
  return affiliation;
}

SxmlNode *WicriOldIsoCodeToPays(SxmlNode *affiliation, SxmlNode *countryNode, char *cityStr, char *adrStr)
{
  /* This function is called when an old european country has attribute wicri:auto */
  char *country;
  country=SxmlLeafText(countryNode);
  switch (country[0])
    {
    case 'R':
      if (strcmp(country, "République tchèque")==0) return WicriTchecoCurationPays(affiliation, countryNode, cityStr, adrStr);
    }
  return NULL;
}
